#include <iostream>
#include <fstream>
#include <list>
#include <cmath>
#include <string.h>
#define MAX_STU 100//读入学生的最大数目

using namespace std;
class Student
{
public:
    char * name;
    char *ID;
    int grade;
    Student()
    {
        name = new char[strlen("Anonymous-----") + 1];
		ID = new char[strlen("NoIdInput------") + 1];
        grade = 0;
    }
    Student(char * pName,char * pID, int pgrade)
        :grade(pgrade)
    {
        name = new char[strlen(pName) + 1];
        strcpy(name, pName);
		ID = new char[strlen(pID) + 1];
        strcpy(ID, pID);
    }
    Student(const Student& rhs)
        :grade(rhs.grade)
    {
        name = new char[strlen(rhs.name) + 1];
        strcpy(name, rhs.name);
		ID = new char[strlen(rhs.ID) + 1];
        strcpy(ID, rhs.ID);
    }
    Student& operator=(const Student& rhs)
    {
        name = new char[strlen(rhs.name) + 1];
        strcpy(name, rhs.name);
		ID = new char[strlen(rhs.ID) + 1];
        strcpy(ID, rhs.ID);
        grade = rhs.grade;
        return *this;
    }
    // overload the == operator
    // for sorting purposes, we consider that two Student objects are "equal"
    // if they have the same grade
    bool operator==(const Student& rhs) const
    {
        return (grade == rhs.grade) ? true : false;
    }
    // overload the < operator
    // for sorting purposes, we consider that a Student object is "less than" another
    // if it's grade is less than the other object's grade
    bool operator<(const Student& rhs) const
    {
        return (grade < rhs.grade) ? true : false;
    }
    // overload the > operator
    // for sorting purposes, we consider that a Student object is "greater than" another
    // if it's grade is greater than the other object's grade
    bool operator>(const Student& rhs) const
    {
        return (grade > rhs.grade) ? true : false;
    }
    // 显示学生的信息
    void print()
    {
        cout << name <<" " <<ID << " " << grade << endl;
    }
    //构造函数
    ~Student()
    {
        delete []name;
	delete []ID;
    }
    //Student *next;
};

list<Student> lst;//学生链表，用于存放学生数据

void inputData()//从文件中读取数据
{
    cout<<"正在从文件读入数据..."<<endl;
    ifstream ifile("student.dat");  
    if(!ifile)  
    {  
        cout<<"student.dat cannot be opened!"<<endl;  
        return;  
    }
    char ch;  
    int i;
    for (i=0;i<MAX_STU;i++)//读取数目  
    {  
		string s_name,s_id,s_grade;
        if(!ifile.get(ch))  
        {
            cout<<"文件已经读完！"<<endl;  
            return;  
        }  
        while (ch!='#')//读取姓名 
        {  
            if (ch==' ')//跳过空格  
            {  
                ifile.get(ch);  
                continue;  
            }
            s_name+=ch; 
            ifile.get(ch);
        }  
        ifile.get(ch);  
        while (ch!='#')//读取学号 
        {  
            if (ch==' ')  
            {  
                ifile.get(ch);//跳过空格  
                continue;  
            }  
            s_id+=ch;  
            ifile.get(ch);  
        }  
        ifile.get(ch);  
        while(ch!='\n')//读取分数  
        {  
            if (ch==' ')  
            {  
                ifile.get(ch);  
                continue;  
            }  
            s_grade+=ch;  
            if(!ifile.get(ch))  
            {
            	cout<<"文件已经读完！"<<endl;  
            	return;  
            }   
        }
	Student temp;
	strcpy(temp.name,s_name.c_str());
	strcpy(temp.ID,s_id.c_str());
	temp.grade=atoi(s_grade.c_str());
	lst.push_back(temp);
    }  
    ifile.close();
}

void print(list<Student> lst, char * name)//输入链表中所有的学生
{
    list<Student>::iterator it;
    cout << name << ":" << endl;
	
    for(it = lst.begin(); it != lst.end(); ++it) {
        it->print();
    }
    cout << endl;
}

void swapPairs(){
    list<Student>::iterator it;
    list<Student>::iterator tmp;
    Student head;
    it = lst.begin();
    while(it != lst.end()) {
        head = *it;
	tmp = it++;
	if(it != lst.end()) {
            *tmp = *(it);
            *(it++) = head; 
	}
    }
}

int main()
{
    inputData();
    print(lst,"Student info as follow:");

    swapPairs();
    print(lst,"Student info as follow:");

    return 0;
}
