#include<iostream>
#include <string>
#include <string.h>
#include <stack>
#include <assert.h>
#include <vector>

using namespace std;

class Solution {
public:
    string removeDuplicateLetters(string s) {
        vector<int> vis(26), num(26);
        for (char ch : s) {
            num[ch - 'a']++;         //1) num 记录了字符串中字母出现的次数;这个就是哈希表的应用；
        }

        string stk;
        for (char ch : s) {
            if (!vis[ch - 'a']) {
                while (!stk.empty() && stk.back() > ch) {
                    if (num[stk.back() - 'a'] > 0) {
                        vis[stk.back() - 'a'] = 0;   //vis代表字母是否已经入栈，0：未入栈；1：已经入栈，如果已经入栈就不要在入栈了；
                        stk.pop_back();
                    } else {
                        break;
                    }
                }
                vis[ch - 'a'] = 1;   //入栈之前，把入栈标志置为1；
                stk.push_back(ch);
            }
            num[ch - 'a'] -= 1;      //2) 每遍历一次字母，对应的Num值减一;当减为0的时候，说明此字母已经遍历完，剩余的字符串里面就没有该字符了.据此判断是否出栈;
        }
        return stk;
    }
};

string stringToString(string input) {
    assert(input.length() >= 2);
    string result;
    for (int i = 1; i < input.length() -1; i++) {
        char currentChar = input[i];
        if (input[i] == '\\') {
            char nextChar = input[i+1];
            switch (nextChar) {
                case '\"': result.push_back('\"'); break;
                case '/' : result.push_back('/'); break;
                case '\\': result.push_back('\\'); break;
                case 'b' : result.push_back('\b'); break;
                case 'f' : result.push_back('\f'); break;
                case 'r' : result.push_back('\r'); break;
                case 'n' : result.push_back('\n'); break;
                case 't' : result.push_back('\t'); break;
                default: break;
            }
            i++;
        } else {
          result.push_back(currentChar);
        }
    }
    return result;
}

string boolToString(bool input) {
    return input ? "True" : "False";
}

int main() {
    string line;
    while (getline(cin, line)) {
        string s = stringToString(line);
        
        string ret = Solution().removeDuplicateLetters(s);

        string out = (ret);
        cout << out << endl;
    }
    return 0;
}
